Kerbal Space Program - Bug #27020

2nd Satellite repair contract fails to complete (refers to a part from the previous 1st contract's vessel)
01/08/2021 11:27 PM - Dunbaratu

Status: Ready to Test Start date: 01/08/2021
Severity: Low % Done: 80%
Assignee: just_jim

Category: Contracts

Target version: 1.11.1

Version: 1.11.0 Language: English (US)
Platform: Windows Mod Related: No
Expansion: Core Game

Description

(Attached quicksave file).

A satellite repair contract from the quicksave refuses to complete because it claims | did not repair the Communicatron 16 antenna
when | absolutely did. This is the contract in question from the attached save file:

CONTRACT

{
guid c072ab91-3b9%-47e6-8dde-9636££7230a3
type = VesselRepairContract

| investigated in the save file and | see something very suspicious.
This contract claims the the part | need to repair is the following one:

PARAM
{
name = RepairPartParameter
state = Incomplete
values = 0,0,0,0,0
bodyName = Kerbin
partName = longAntenna
partPersistentId = 1509972433
vesselPersistentId = 3819982714
}

What | find suspicious about this is that while a part with persistentld=1509972433 does exist in the save file, it is NOT on a vessel
with persistentld=3819982714 as described by this contract parameter. It's on a vessel with persistentld=490346003 instead.

That older vessel, with persistentld=490346003, also coincidentally happens to be one that was spawned by this very same type of
contract earlier in the game.

| suspect this: This type of contract only works right the first time it spawns a vessel of this specific design. The second time the
same design of vessel is spawned by a second instance of this contract, it won't complete because it's using a part ID that's on the
vessel the first contract spawned, not the new second vessel.

History

#1 - 01/12/2021 12:12 AM - just_jim
- Status changed from New to Confirmed

- % Done changed from 0 to 10

Dunbaratu, nice detective work. Thank you!

#3 - 01/12/2021 12:13 AM - just_jim

- Assignee set to just jim

#4 - 01/29/2021 01:44 PM - victorr
- Status changed from Confirmed to Ready to Test
- Target version setto 1.11.1

- % Done changed from 10 to 80

We've made some changes in the latest version of the game and would like some feedback on this issue. Thanks.

#5 - 02/27/2021 04:13 PM - DeepProbe
- File Can_t fix Damaged Kerbin MLA Satellite 4L-8.loadmeta added
- File Can_t fix Damaged Kerbin MLA Satellite 4L-8.sfs added

victorr wrote:

... would like some feedback on this issue...

Looks like bug still there for me in 1.11.1.3066 (Windows x64) en-us.
Savefile attached.

2 satellites of same design spawned:

"Aging The Mun RSA Satellite 4B81" - over Mun, "install part" contract.
"Damaged Kerbin MLA Sattelite 4L-8" - over Kerbin, "repair part" contract.
Engeneer fixing part at 4L-8 - game ignores.

Also, part cannot be detached before repairing - game resists ("operation in progress, cannot detach") - but after repair (not counted by contract) part

can be detached, reattached and after that will appears as broken again.

Files

demonstrate_sat_repair_bug.loadmeta 398 Bytes 01/08/2021 Dunbaratu

demonstrate_sat_repair_bug.sfs 5.33 MB 01/08/2021 Dunbaratu

Can_t fix Damaged Kerbin MLA Satellite 4L-8.loadmeta 399 Bytes 02/27/2021 DeepProbe

Can_t fix Damaged Kerbin MLA Satellite 4L-8.sfs 7.57 MB 02/27/2021 DeepProbe
